#!/bin/bash

checkfiles="/rhev/data-center/mnt"
checkfiles+=" /rhev/data-center/hsm-tasks"

result=1

function check_result () {
    result=1
    for filepath in $checkfiles; do
        if [ -e $filepath ]; then
            a=0
        else
            echo $filepath not exist, this is try $i
            result=0
        fi
    done
}

trytimes=20
sleeptime=1

function clean_and_test() {
    ./clean.sh
    for ((i=0;i<$trytimes;i++));do
        check_result
        if [ $result == 1 ]; then
            break
        fi
        sleep $sleeptime
    done

    echo result $result
    if [ $result == 1 ]; then
        echo Succuss!
    else
        echo Fail!
    fi
}

testround=100
if [[ $# > 0 ]] && [[ $1 != '' ]]; then
    testround=$1
fi
echo start tests with $testround rounds

for ((j=0;j<$testround;j++));do
    echo testround $j starting...
    clean_and_test
    if [ $result == 0 ]; then
        break
    else
        :
    fi
    ((num1=$RANDOM%2000+1000))
    randSleep=$( echo "scale=3; $num1/1000" | bc)
    echo sleeping $randSleep seconds
    sleep $randSleep
done

echo Final Result: $result, roundcount $j, expect is $testround
